.nolist
include \masm32\include\masm32rt.inc
;include \masm32\MasmBasic\MasmBasic.inc 
.686
.xmm
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 20000

.data
align 16
;Dummy1	db 1,1	; unaligned
Src1	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
   REPEAT 38
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
   ENDM
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing Algos!", 0
align 16
;Dummy2	db 1	; unaligned
Src2	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
   REPEAT 38
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
   ENDM
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algot!", 0
align 16
Srcs1	db "A string ?", 0, "abcdefghij"
align 16
Srcs2	db "A string !", 0, "ABCDEFGHIJ"
LenSrcs1	dd 10
LenSrcs2	dd 10

.data?
Dest	db 100 dup(?)
LenSrc1	dd ?
LenSrc2	dd ?

.code
start:
	if 0
		push offset Src1
		push offset Src2
		call StrCmpSSE
		print str$(eax)
;		getkey
		exit
	endif
	push 1
	call ShowCpu	; prints the brand string and returns SSE level@
	print "String comparison: short string 10 bytes, long string "
	mov LenSrc1, len(offset Src1)
	mov LenSrc2, len(offset Src2)
	print str$(LenSrc1), 13, 10
	REPEAT 3
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src1
		push offset Src2
		call StrCmpSSE
	counter_end
	print str$(eax), 9, "cycles for SSE, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
	lea esi, Src1
	lea edi, Src2
	movzx eax, BYTE ptr [esi]
	movzx ebx, BYTE ptr [edi]
	.While eax == ebx
@@:		or eax, ebx
		jz @F
		inc esi
		inc edi
		movzx eax, BYTE ptr [esi]
		movzx ebx, BYTE ptr [edi]
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for qWord, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src1
		push offset Src2
		call Lingo32
	counter_end
	print str$(eax), 9, "cycles for Lingo, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
	mov esi, offset Src1
	mov edi, offset Src2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
	mov esi, offset Src1
	mov edi, offset Src2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		.Break .if !eax
		.Break .if !edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx check null, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src1
		lea edi, Src2
		mov ecx, LenSrc1
		repe cmpsb
	counter_end
	print str$(eax), 9, "cycles for repe cmpsb, long string", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src1
		lea edi, Src2
		invoke lstrcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for lstrcmp, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src1
		lea edi, Src2
		invoke crt_strcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for crt_strcmp, long string", 13, 10, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		push offset Srcs1
		push offset Srcs2
		call StrCmpSSE
	counter_end
	print str$(eax), 9, "cycles for SSE, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
	lea esi, Srcs1
	lea edi, Srcs2
	movzx eax, BYTE ptr [esi]
	movzx ebx, BYTE ptr [edi]
	.While eax == ebx
@@:		or eax,ebx
		jz @F
		inc esi
		inc edi
		movzx eax, BYTE ptr [esi]
		movzx ebx, BYTE ptr [edi]
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for qWord, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
	mov esi, offset Srcs1
	mov edi, offset Srcs2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
	mov esi, offset Srcs1
	mov edi, offset Srcs2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		.Break .if !eax
		.Break .if !edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx check null, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		lea esi, Srcs1
		lea edi, Srcs2
		mov ecx, LenSrcs1
		repe cmpsb
	counter_end
	print str$(eax), 9, "cycles for repe cmpsb, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		lea esi, Srcs1
		lea edi, Srcs2
		invoke lstrcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for lstrcmp, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		lea esi, Srcs1
		lea edi, Srcs2
		invoke crt_strcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for crt_strcmp, 10 bytes", 13, 10, 10
	ENDM
	print "Codesizes:", 13, 10
	print "Lingo:", 9
	mov eax, Lingo32_E
	sub eax, Lingo32_S
	print str$(eax), 13, 10
	print "SSE:", 9
	mov eax, StrCmpSSE_E
	sub eax, StrCmpSSE_S
	print str$(eax), 13, 10
	inkey "--- ok ---"
	exit

push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

StrCmpSSE_S:
StrCmpSSE proc
	push esi
	push edi
	mov esi, [esp+12]
	mov edi, [esp+16]
	pxor xmm2, xmm2
	test edi, 15
	je E1
	xchg esi, edi
	test edi, 15
	je E1
	mov edx, edi
	lddqu xmm1, oword ptr [edi]
	lddqu xmm0, oword ptr [esi]
	pcmpeqb xmm0, xmm1		; compare packed bytes in [m128] and xmm0 for equality
	and edi, -16		; align initial pointer to 16-byte boundary
	sub edx, edi
	push esi
	sub esi, edx
	test esi, 15
	je aE2
	jmp uE2
E1:	push esi
	test esi, 15
;	int 3
	je aL1
uL1:	lddqu xmm0, oword ptr [esi]
	pcmpeqb xmm0, [edi]		; compare packed bytes in [m128] and xmm0 for equality
uE2:	lea edi, [edi+16]			; 
	lea esi, [esi+16]			; 
	pmovmskb edx, xmm0	; set byte mask in eax
	cmp edx, 65535
	je uL1
	jmp xEnd

aL1:	movapd xmm0, oword ptr [esi]		; 300 instead of 370 for 2*aligned
	pcmpeqb xmm0, [edi]		; compare packed bytes in [m128] and xmm0 for equality
aE2:	lea edi, [edi+16]			; 
	lea esi, [esi+16]			; 
	pmovmskb edx, xmm0	; set byte mask in eax
	cmp edx, 65535
	je aL1

xEnd:
	; lea eax, [esi-16]
	mov eax, esi
	pop esi
	sub eax, esi
	not edx
	bsf edx, edx
	lea edx, [eax+edx-16]		; 16 if null-based
	mov esi, [esp+12]
	mov edi, [esp+16]
	movzx eax, byte ptr [esi+edx]		; edx returns 0-based position of first mismatch
	movzx esi, byte ptr [edi+edx]		; eax returns difference of mismatching bytes
	sub eax, esi
	pop edi
	pop esi
	ret 8
StrCmpSSE endp
StrCmpSSE_E:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
;...........................................................................................
comment * New lstrcmp by Lingo *
Align	16
Lingo32_S:
db			8Dh, 49h, 0, 90h
Lingo32 proc lpString1:DWORD, lpString12:DWORD
	mov edx, [esp+4]		; edx-> lpString1
	xor eax, eax		; eax->index
	mov [esp+4], esi		; save esi register
	mov esi, edx		; esi-> lpString1
	mov edx, [edx]		; edx-> lpString1
	mov ecx, [esp+8]		; ecx-> lpString2
	mov [esp+8], edi		; save edi register
	lea edi, [edx+0FEFEFEFFh]
	cmp edx, [ecx]		; ecx-> lpString2
	jne @K1
	test edi, 80808080h
	jne @@2
	mov edx, [esi+4]
	add eax, 4
	cmp edx, [ecx+4]		; ecx-> lpString2
	mov edi, 80808080h		; edi->mask-> 80808080h
	jne @K1
@@:
	add edx, 0FEFEFEFFh
	test edx, edi		; edi->mask-> 80808080h
	jne @@1		;found zero or >80h
	mov edx, [esi+eax+4]		; esi-> lpString1
	add eax, 4
	cmp edx, [ecx+eax]		; ecx-> lpString2
	je @b
@K1:
	movzx edi, byte ptr [ecx+eax]		; ecx-> lpString2
	and edx, 0FFh		; edi-> lpString1
	sub edx, edi
	jne @K2
	add edi, edi
	je @K2
	movzx edi, byte ptr [ecx+eax+1]		; ecx-> lpString2
	movzx edx, byte ptr [esi+eax+1]		; esi-> lpString1
	sub edx, edi
	jne @K2
	add edi, edi
	je @K2
	movzx edi, byte ptr [ecx+eax+2]		; ecx-> lpString2
	movzx edx, byte ptr [esi+eax+2]		; esi-> lpString1
	sub edx, edi
	jne @K2
	add edi, edi
	je @K2
	movzx edx, byte ptr [ecx+eax+3]		; ecx-> lpString2
	movzx eax, byte ptr [esi+eax+3]		; esi-> lpString1
	mov esi, [esp+4]		; restore esi register
	sub eax, edx		; 2 strings are equal or not
	mov edi, [esp+8]		; restore edi register
	ret 8
@K2:
	mov esi, [esp+4]		; restore esi register
	mov eax, edx		; 2 strings are equal or not
	mov edi, [esp+8]		; restore edi register
	ret 8
; ..............................................................................................
db 8Dh, 0A4h, 24h, 0, 0, 0, 0, 90h		; nop's
@@1:		; there is a zero or >80h in the first string
	add edx, 1010101h		; restore edx
@@2:
	cmp dl, [ecx+eax]		; ecx-> lpString2
	jne @M1
	test dl, dl
	je @@3
	cmp dh,[ecx+eax+1]		; ecx-> lpString2
	jne @M2
	test dh, dh
	je @@3
	shr edx, 16
	cmp dl, [ecx+eax+2]		; ecx-> lpString2
	jne @M3
	test dl, dl
	je @@3
	cmp dh, [ecx+eax+3]		; ecx-> lpString2
	jne @M4
	test dh, dh
	je @@3
	mov edx, [esi+eax+4]		; esi-> lpString1
@@:
	and edx, 07F7F7F7FH
	add eax, 4
	add edx, 0FEFEFEFFh
	test edx, edi		; edi->mask-> 80808080h
	mov edx, [esi+eax]		; esi-> lpString1
	jne @@2		; there is a zero or 80h in the first string
	cmp edx, [ecx+eax]		; ecx-> lpString2
	je @b
	jne @K1
@@3:
	mov esi, [esp+4]		; restore esi register
	xor eax, eax		; 2 strings are equal
	mov edi, [esp+8]		; restore edi register
	ret 8
@M1:
	movzx edi, byte ptr [ecx+eax]		; ecx-> lpString2
	movzx eax, dl
	mov esi, [esp+4]		; restore esi register
	sub eax, edi
	mov edi, [esp+8]		; restore edi register
	ret 8
@M2:
	movzx edi, byte ptr [ecx+eax+1]		; ecx-> lpString2
	movzx eax, dh
	mov esi, [esp+4]		; restore esi register
	sub eax, edi
	mov edi, [esp+8]		; restore edi register
	ret 8
@M3:
	movzx edi, byte ptr [ecx+eax+2]		; ecx-> lpString2
	movzx eax, dl
	mov esi, [esp+4]		; restore esi register
	sub eax, edi
	mov edi, [esp+8]		; restore edi register
	ret 8
@M4:
	movzx edi, byte ptr [ecx+eax+3]		; ecx-> lpString2
	movzx eax, dh
	mov esi, [esp+4]		; restore esi register
	sub eax, edi
	mov edi, [esp+8]		; restore edi register
	ret 8
	Lingo32 endp
Lingo32_E:
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
OPT_Olly	2


[CPU]
Placement=0,0,392,515,3	; shows 3 xmm regs
